const
  Opcodes: array[Byte] of TOpcodeData = (
    { $00 } (Mnemonic:'add'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $01 } (Mnemonic:'add'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $02 } (Mnemonic:'add'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $03 } (Mnemonic:'add'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $04 } (Mnemonic:'add'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $05 } (Mnemonic:'add'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $06 } (Mnemonic:'push'; Arg1:argRegES; Arg2:argNone; Prefix:False),
    { $07 } (Mnemonic:'pop'; Arg1:argRegES; Arg2:argNone; Prefix:False),
    { $08 } (Mnemonic:'or'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $09 } (Mnemonic:'or'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $0A } (Mnemonic:'or'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $0B } (Mnemonic:'or'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $0C } (Mnemonic:'or'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $0D } (Mnemonic:'or'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $0E } (Mnemonic:'push'; Arg1:argRegCS; Arg2:argNone; Prefix:False),
    { $0F } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $10 } (Mnemonic:'adc'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $11 } (Mnemonic:'adc'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $12 } (Mnemonic:'adc'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $13 } (Mnemonic:'adc'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $14 } (Mnemonic:'adc'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $15 } (Mnemonic:'adc'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $16 } (Mnemonic:'push'; Arg1:argRegSS; Arg2:argNone; Prefix:False),
    { $17 } (Mnemonic:'pop'; Arg1:argRegSS; Arg2:argNone; Prefix:False),
    { $18 } (Mnemonic:'sbb'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $19 } (Mnemonic:'sbb'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $1A } (Mnemonic:'sbb'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $1B } (Mnemonic:'sbb'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $1C } (Mnemonic:'sbb'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $1D } (Mnemonic:'sbb'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $1E } (Mnemonic:'push'; Arg1:argRegDS; Arg2:argNone; Prefix:False),
    { $1F } (Mnemonic:'pop'; Arg1:argRegDS; Arg2:argNone; Prefix:False),
    { $20 } (Mnemonic:'and'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $21 } (Mnemonic:'and'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $22 } (Mnemonic:'and'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $23 } (Mnemonic:'and'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $24 } (Mnemonic:'and'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $25 } (Mnemonic:'and'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $26 } (Mnemonic:'seges'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $27 } (Mnemonic:'daa'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $28 } (Mnemonic:'sub'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $29 } (Mnemonic:'sub'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $2A } (Mnemonic:'sub'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $2B } (Mnemonic:'sub'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $2C } (Mnemonic:'sub'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $2D } (Mnemonic:'sub'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $2E } (Mnemonic:'segcs'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $2F } (Mnemonic:'das'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $30 } (Mnemonic:'xor'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $31 } (Mnemonic:'xor'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $32 } (Mnemonic:'xor'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $33 } (Mnemonic:'xor'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $34 } (Mnemonic:'xor'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $35 } (Mnemonic:'xor'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $36 } (Mnemonic:'segss'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $37 } (Mnemonic:'aaa'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $38 } (Mnemonic:'cmp'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $39 } (Mnemonic:'cmp'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $3A } (Mnemonic:'cmp'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $3B } (Mnemonic:'cmp'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $3C } (Mnemonic:'cmp'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $3D } (Mnemonic:'cmp'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $3E } (Mnemonic:'segds'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $3F } (Mnemonic:'aas'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $40 } (Mnemonic:'inc'; Arg1:argRegAX; Arg2:argNone; Prefix:False),
    { $41 } (Mnemonic:'inc'; Arg1:argRegCX; Arg2:argNone; Prefix:False),
    { $42 } (Mnemonic:'inc'; Arg1:argRegDX; Arg2:argNone; Prefix:False),
    { $43 } (Mnemonic:'inc'; Arg1:argRegBX; Arg2:argNone; Prefix:False),
    { $44 } (Mnemonic:'inc'; Arg1:argRegSP; Arg2:argNone; Prefix:False),
    { $45 } (Mnemonic:'inc'; Arg1:argRegBP; Arg2:argNone; Prefix:False),
    { $46 } (Mnemonic:'inc'; Arg1:argRegSI; Arg2:argNone; Prefix:False),
    { $47 } (Mnemonic:'inc'; Arg1:argRegDI; Arg2:argNone; Prefix:False),
    { $48 } (Mnemonic:'dec'; Arg1:argRegAX; Arg2:argNone; Prefix:False),
    { $49 } (Mnemonic:'dec'; Arg1:argRegCX; Arg2:argNone; Prefix:False),
    { $4A } (Mnemonic:'dec'; Arg1:argRegDX; Arg2:argNone; Prefix:False),
    { $4B } (Mnemonic:'dec'; Arg1:argRegBX; Arg2:argNone; Prefix:False),
    { $4C } (Mnemonic:'dec'; Arg1:argRegSP; Arg2:argNone; Prefix:False),
    { $4D } (Mnemonic:'dec'; Arg1:argRegBP; Arg2:argNone; Prefix:False),
    { $4E } (Mnemonic:'dec'; Arg1:argRegSI; Arg2:argNone; Prefix:False),
    { $4F } (Mnemonic:'dec'; Arg1:argRegDI; Arg2:argNone; Prefix:False),
    { $50 } (Mnemonic:'push'; Arg1:argRegAX; Arg2:argNone; Prefix:False),
    { $51 } (Mnemonic:'push'; Arg1:argRegCX; Arg2:argNone; Prefix:False),
    { $52 } (Mnemonic:'push'; Arg1:argRegDX; Arg2:argNone; Prefix:False),
    { $53 } (Mnemonic:'push'; Arg1:argRegBX; Arg2:argNone; Prefix:False),
    { $54 } (Mnemonic:'push'; Arg1:argRegSP; Arg2:argNone; Prefix:False),
    { $55 } (Mnemonic:'push'; Arg1:argRegBP; Arg2:argNone; Prefix:False),
    { $56 } (Mnemonic:'push'; Arg1:argRegSI; Arg2:argNone; Prefix:False),
    { $57 } (Mnemonic:'push'; Arg1:argRegDI; Arg2:argNone; Prefix:False),
    { $58 } (Mnemonic:'pop'; Arg1:argRegAX; Arg2:argNone; Prefix:False),
    { $59 } (Mnemonic:'pop'; Arg1:argRegCX; Arg2:argNone; Prefix:False),
    { $5A } (Mnemonic:'pop'; Arg1:argRegDX; Arg2:argNone; Prefix:False),
    { $5B } (Mnemonic:'pop'; Arg1:argRegBX; Arg2:argNone; Prefix:False),
    { $5C } (Mnemonic:'pop'; Arg1:argRegSP; Arg2:argNone; Prefix:False),
    { $5D } (Mnemonic:'pop'; Arg1:argRegBP; Arg2:argNone; Prefix:False),
    { $5E } (Mnemonic:'pop'; Arg1:argRegSI; Arg2:argNone; Prefix:False),
    { $5F } (Mnemonic:'pop'; Arg1:argRegDI; Arg2:argNone; Prefix:False),
    { $60 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $61 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $62 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $63 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $64 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $65 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $66 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $67 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $68 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $69 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6A } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6B } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6C } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6D } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6E } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $6F } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $70 } (Mnemonic:'jo'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $71 } (Mnemonic:'jno'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $72 } (Mnemonic:'jb'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $73 } (Mnemonic:'jae'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $74 } (Mnemonic:'jz'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $75 } (Mnemonic:'jnz'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $76 } (Mnemonic:'jbe'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $77 } (Mnemonic:'ja'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $78 } (Mnemonic:'js'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $79 } (Mnemonic:'jns'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7A } (Mnemonic:'jpe'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7B } (Mnemonic:'jpo'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7C } (Mnemonic:'jl'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7D } (Mnemonic:'jge'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7E } (Mnemonic:'jle'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $7F } (Mnemonic:'jg'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $80 } (Mnemonic:'<ArOp>'; Arg1:argRegMem8; Arg2:argImm8; Prefix:False),
    { $81 } (Mnemonic:'<ArOp>'; Arg1:argRegMem16; Arg2:argImm16; Prefix:False),
    { $82 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $83 } (Mnemonic:'<ArOp>'; Arg1:argRegMem16; Arg2:argSImm8; Prefix:False),
    { $84 } (Mnemonic:'test'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $85 } (Mnemonic:'test'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $86 } (Mnemonic:'xchg'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $87 } (Mnemonic:'xchg'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $88 } (Mnemonic:'mov'; Arg1:argRegMem8; Arg2:argReg8; Prefix:False),
    { $89 } (Mnemonic:'mov'; Arg1:argRegMem16; Arg2:argReg16; Prefix:False),
    { $8A } (Mnemonic:'mov'; Arg1:argReg8; Arg2:argRegMem8; Prefix:False),
    { $8B } (Mnemonic:'mov'; Arg1:argReg16; Arg2:argRegMem16; Prefix:False),
    { $8C } (Mnemonic:'mov'; Arg1:argRegMem16; Arg2:argSegReg; Prefix:False),
    { $8D } (Mnemonic:'lea'; Arg1:argReg16; Arg2:argMem8; Prefix:False),
    { $8E } (Mnemonic:'mov'; Arg1:argSegReg; Arg2:argRegMem16; Prefix:False),
    { $8F } (Mnemonic:'pop'; Arg1:argRegMem16; Arg2:argNone; Prefix:False),
    { $90 } (Mnemonic:'nop'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $91 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegCX; Prefix:False),
    { $92 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegDX; Prefix:False),
    { $93 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegBX; Prefix:False),
    { $94 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegSP; Prefix:False),
    { $95 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegBP; Prefix:False),
    { $96 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegSI; Prefix:False),
    { $97 } (Mnemonic:'xchg'; Arg1:argRegAX; Arg2:argRegDI; Prefix:False),
    { $98 } (Mnemonic:'cbw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $99 } (Mnemonic:'cwd'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $9A } (Mnemonic:'call'; Arg1:argFar; Arg2:argNone; Prefix:False),
    { $9B } (Mnemonic:'wait'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $9C } (Mnemonic:'pushf'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $9D } (Mnemonic:'popf'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $9E } (Mnemonic:'sahf'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $9F } (Mnemonic:'lahf'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $A0 } (Mnemonic:'mov'; Arg1:argRegAL; Arg2:argMemOffs8; Prefix:False),
    { $A1 } (Mnemonic:'mov'; Arg1:argRegAX; Arg2:argMemOffs16; Prefix:False),
    { $A2 } (Mnemonic:'mov'; Arg1:argMemOffs8; Arg2:argRegAL; Prefix:False),
    { $A3 } (Mnemonic:'mov'; Arg1:argMemOffs16; Arg2:argRegAX; Prefix:False),
    { $A4 } (Mnemonic:'movsb'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $A5 } (Mnemonic:'movsw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $A6 } (Mnemonic:'cmpsb'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $A7 } (Mnemonic:'cmpsw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $A8 } (Mnemonic:'test'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $A9 } (Mnemonic:'test'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $AA } (Mnemonic:'stosb'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $AB } (Mnemonic:'stosw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $AC } (Mnemonic:'lodsb'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $AD } (Mnemonic:'lodsw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $AE } (Mnemonic:'scasb'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $AF } (Mnemonic:'scasw'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $B0 } (Mnemonic:'mov'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $B1 } (Mnemonic:'mov'; Arg1:argRegCL; Arg2:argImm8; Prefix:False),
    { $B2 } (Mnemonic:'mov'; Arg1:argRegDL; Arg2:argImm8; Prefix:False),
    { $B3 } (Mnemonic:'mov'; Arg1:argRegBL; Arg2:argImm8; Prefix:False),
    { $B4 } (Mnemonic:'mov'; Arg1:argRegAH; Arg2:argImm8; Prefix:False),
    { $B5 } (Mnemonic:'mov'; Arg1:argRegCH; Arg2:argImm8; Prefix:False),
    { $B6 } (Mnemonic:'mov'; Arg1:argRegDH; Arg2:argImm8; Prefix:False),
    { $B7 } (Mnemonic:'mov'; Arg1:argRegBH; Arg2:argImm8; Prefix:False),
    { $B8 } (Mnemonic:'mov'; Arg1:argRegAX; Arg2:argImm16; Prefix:False),
    { $B9 } (Mnemonic:'mov'; Arg1:argRegCX; Arg2:argImm16; Prefix:False),
    { $BA } (Mnemonic:'mov'; Arg1:argRegDX; Arg2:argImm16; Prefix:False),
    { $BB } (Mnemonic:'mov'; Arg1:argRegBX; Arg2:argImm16; Prefix:False),
    { $BC } (Mnemonic:'mov'; Arg1:argRegSP; Arg2:argImm16; Prefix:False),
    { $BD } (Mnemonic:'mov'; Arg1:argRegBP; Arg2:argImm16; Prefix:False),
    { $BE } (Mnemonic:'mov'; Arg1:argRegSI; Arg2:argImm16; Prefix:False),
    { $BF } (Mnemonic:'mov'; Arg1:argRegDI; Arg2:argImm16; Prefix:False),
    { $C0 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $C1 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $C2 } (Mnemonic:'retn'; Arg1:argImm16; Arg2:argNone; Prefix:False),
    { $C3 } (Mnemonic:'retn'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $C4 } (Mnemonic:'les'; Arg1:argReg16; Arg2:argMem32; Prefix:False),
    { $C5 } (Mnemonic:'lds'; Arg1:argReg16; Arg2:argMem32; Prefix:False),
    { $C6 } (Mnemonic:'mov'; Arg1:argMem8; Arg2:argImm8; Prefix:False),
    { $C7 } (Mnemonic:'mov'; Arg1:argMem16; Arg2:argImm16; Prefix:False),
    { $C8 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $C9 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $CA } (Mnemonic:'retf'; Arg1:argImm16; Arg2:argNone; Prefix:False),
    { $CB } (Mnemonic:'retf'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $CC } (Mnemonic:'int'; Arg1:argConst3; Arg2:argNone; Prefix:False),
    { $CD } (Mnemonic:'int'; Arg1:argImm8; Arg2:argNone; Prefix:False),
    { $CE } (Mnemonic:'into'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $CF } (Mnemonic:'iret'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $D0 } (Mnemonic:'<ShfOp>'; Arg1:argRegMem8; Arg2:argConst1; Prefix:False),
    { $D1 } (Mnemonic:'<ShfOp>'; Arg1:argRegMem16; Arg2:argConst1; Prefix:False),
    { $D2 } (Mnemonic:'<ShfOp>'; Arg1:argRegMem8; Arg2:argRegCL; Prefix:False),
    { $D3 } (Mnemonic:'<ShfOp>'; Arg1:argRegMem16; Arg2:argRegCL; Prefix:False),
    { $D4 } (Mnemonic:'aam'; Arg1:argImm8; Arg2:argNone; Prefix:False),
    { $D5 } (Mnemonic:'aad'; Arg1:argImm8; Arg2:argNone; Prefix:False),
    { $D6 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $D7 } (Mnemonic:'xlat'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $D8 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $D9 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DA } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DB } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DC } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DD } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DE } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $DF } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $E0 } (Mnemonic:'loopnz'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $E1 } (Mnemonic:'loopz'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $E2 } (Mnemonic:'loop'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $E3 } (Mnemonic:'jcxz'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $E4 } (Mnemonic:'in'; Arg1:argRegAL; Arg2:argImm8; Prefix:False),
    { $E5 } (Mnemonic:'in'; Arg1:argRegAX; Arg2:argImm8; Prefix:False),
    { $E6 } (Mnemonic:'out'; Arg1:argImm8; Arg2:argRegAL; Prefix:False),
    { $E7 } (Mnemonic:'out'; Arg1:argImm8; Arg2:argRegAX; Prefix:False),
    { $E8 } (Mnemonic:'call'; Arg1:argNear; Arg2:argNone; Prefix:False),
    { $E9 } (Mnemonic:'jmp'; Arg1:argNear; Arg2:argNone; Prefix:False),
    { $EA } (Mnemonic:'jmp'; Arg1:argFar; Arg2:argNone; Prefix:False),
    { $EB } (Mnemonic:'jmp'; Arg1:argShort; Arg2:argNone; Prefix:False),
    { $EC } (Mnemonic:'in'; Arg1:argRegAL; Arg2:argRegDX; Prefix:False),
    { $ED } (Mnemonic:'in'; Arg1:argRegAX; Arg2:argRegDX; Prefix:False),
    { $EE } (Mnemonic:'out'; Arg1:argRegDX; Arg2:argRegAL; Prefix:False),
    { $EF } (Mnemonic:'out'; Arg1:argRegDX; Arg2:argRegAX; Prefix:False),
    { $F0 } (Mnemonic:'lock'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $F1 } (Mnemonic:''; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $F2 } (Mnemonic:'repne'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $F3 } (Mnemonic:'rep'; Arg1:argNone; Arg2:argNone; Prefix:True),
    { $F4 } (Mnemonic:'hlt'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $F5 } (Mnemonic:'cmc'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $F6 } (Mnemonic:'<Grp1>'; Arg1:argRegMem8; Arg2:argNone; Prefix:False),
    { $F7 } (Mnemonic:'<Grp1>'; Arg1:argRegMem16; Arg2:argNone; Prefix:False),
    { $F8 } (Mnemonic:'clc'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $F9 } (Mnemonic:'stc'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $FA } (Mnemonic:'cli'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $FB } (Mnemonic:'sti'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $FC } (Mnemonic:'cld'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $FD } (Mnemonic:'std'; Arg1:argNone; Arg2:argNone; Prefix:False),
    { $FE } (Mnemonic:'<Grp2>'; Arg1:argRegMem8; Arg2:argNone; Prefix:False),
    { $FF } (Mnemonic:'<Grp3>'; Arg1:argRegMem16; Arg2:argNone; Prefix:False));

  ArOp: array[0..7] of string[7] = (
    'add',
    'or',
    'adc',
    'sbb',
    'and',
    'sub',
    'xor',
    'cmp');

  Grp1: array[0..7] of string[7] = (
    'test',	{ r/m,imm }
    '',
    'not',
    'neg',
    'mul',
    'imul',
    'div',
    'idiv');

  Grp2: array[0..7] of string[7] = (
    'inc',
    'dec',
    '',
    '',
    '',
    '',
    '',
    '');

  Grp3: array[0..7] of string[7] = (
    'inc',
    'dec',
    'call',	{ word }
    'call',	{ dword }
    'jmp',	{ word }
    'jmp',	{ dword }
    'push',
    '');

  ShfOp: array[0..7] of string[7] = (
    'rol',
    'ror',
    'rcl',
    'rcr',
    'shl',	{ ; }
    'shr',
    '',
    'sar');
